Index: squid/src/auth/ntlm/auth_ntlm.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/auth/ntlm/auth_ntlm.c,v
retrieving revision 1.1.2.17
retrieving revision 1.1.2.18
diff -u -r1.1.2.17 -r1.1.2.18
--- squid/src/auth/ntlm/auth_ntlm.c	7 Jan 2001 02:49:32 -0000	1.1.2.17
+++ squid/src/auth/ntlm/auth_ntlm.c	7 Jan 2001 09:48:32 -0000	1.1.2.18
@@ -406,144 +398,139 @@
     valid = cbdataValid(r->data);
     cbdataUnlock(r->data);
     if (valid) {
-        if (reply) {
-            /* seperate out the useful data */
-            if (strncasecmp(reply, "TT ", 3) == 0) {
-	        reply += 3;
-                /* we have been given a Challenge */
-                /* we should check we weren't given an empty challenge */
+	if (reply) {
+	    /* seperate out the useful data */
+	    if (strncasecmp(reply, "TT ", 3) == 0) {
+		reply += 3;
+		/* we have been given a Challenge */
+		/* we should check we weren't given an empty challenge */
 #if 0
-	        result=S_HELPER_RESERVE;
+		result = S_HELPER_RESERVE;
 #endif
-                /* copy the challenge to the state data */
-                helperstate=helperStatefulServerGetData(lastserver);
-                if (helperstate == NULL) fatal ("lost NTLm helper state! quitting\n");
-                helperstate->challenge=xstrndup(reply, NTLM_CHALLENGE_SZ+5);
-                helperstate->challengeuses=0;
-                helperstate->renewed=squid_curtime;
-                /* and we satisfy the request that happended on the refresh boundary */
-                /* note this code is now in two places FIXME */
-                assert(r->auth_user_request != NULL);
-                assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
-                auth_user_request=r->auth_user_request;
-                ntlm_request=auth_user_request->scheme_data;
-                assert(ntlm_request != NULL);
-                result=S_HELPER_DEFER;
+		/* copy the challenge to the state data */
+		helperstate = helperStatefulServerGetData(lastserver);
+		if (helperstate == NULL)
+		    fatal("lost NTLm helper state! quitting\n");
+		helperstate->challenge = xstrndup(reply, NTLM_CHALLENGE_SZ + 5);
+		helperstate->challengeuses = 0;
+		helperstate->renewed = squid_curtime;
+		/* and we satisfy the request that happended on the refresh boundary */
+		/* note this code is now in two places FIXME */
+		assert(r->auth_user_request != NULL);
+		assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
+		auth_user_request = r->auth_user_request;
+		ntlm_request = auth_user_request->scheme_data;
+		assert(ntlm_request != NULL);
+		result = S_HELPER_DEFER;
 #if 0
-                nextserver=lastserver;
+		nextserver = lastserver;
 #endif
-	        debug(29,9)("authenticateNTLMHandleReply: helper '%d'\n",lastserver);
-                assert(ntlm_request->auth_state == AUTHENTICATE_STATE_NEGOTIATE);
+		debug(29, 9) ("authenticateNTLMHandleReply: helper '%d'\n", lastserver);
+		assert(ntlm_request->auth_state == AUTHENTICATE_STATE_NEGOTIATE);
 //                auth_user->auth_data.ntlm_auth.auth_state = AUTHENTICATE_STATE_CHALLENGE;
-                ntlm_request->authhelper = lastserver;
-                ntlm_request->authchallenge = xstrndup(reply, NTLM_CHALLENGE_SZ+5);
-            } 
-            else if (strncasecmp(reply, "AF ", 3) == 0) {
-	        /* we're finished, release the helper*/
-                reply+=3;
-                assert(r->auth_user_request != NULL);
-                assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
-                auth_user_request=r->auth_user_request;
-                assert(auth_user_request->scheme_data != NULL);
-                ntlm_request = auth_user_request->scheme_data;
-                auth_user    = auth_user_request->auth_user;
-                ntlm_user    = auth_user_request->auth_user->scheme_data;
-                assert(ntlm_user != NULL);
-	        result=S_HELPER_RELEASE;
-                /* we only expect OK when finishing the handshake */
-                assert(ntlm_request->auth_state == AUTHENTICATE_STATE_RESPONSE);
-                ntlm_user->username = xstrndup(reply, MAX_LOGIN_SZ);
-                ntlm_request->authhelper = NULL;
-                auth_user->flags.credentials_ok = 1; /* login ok */
-            } 
-            else if (strncasecmp(reply, "NA ", 3) == 0) {
-                /* TODO: only work with auth_user here if it exists */
-                assert(r->auth_user_request != NULL);
-                assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
-                auth_user_request=r->auth_user_request;
-                auth_user        = auth_user_request->auth_user;
-                assert(auth_user != NULL);
-                ntlm_user        = auth_user->scheme_data;
-                ntlm_request     = auth_user_request->scheme_data;
-                assert ((ntlm_user != NULL ) && (ntlm_request != NULL));
-                /* todo: action of Negotiate state on error */
-                result=S_HELPER_RELEASE; /*some error has occured. no more requests */
-                ntlm_request->authhelper = NULL;
-                auth_user->flags.credentials_ok = 2; /* Login/Usercode failed */
-                debug(29, 4) ("authenticateNTLMHandleReply: Error validating user via NTLM.\n");
-                ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
-                if ((t = strchr(reply, ' ')))/* strip after a space */
+		ntlm_request->authhelper = lastserver;
+		ntlm_request->authchallenge = xstrndup(reply, NTLM_CHALLENGE_SZ + 5);
+	    } else if (strncasecmp(reply, "AF ", 3) == 0) {
+		/* we're finished, release the helper */
+		reply += 3;
+		assert(r->auth_user_request != NULL);
+		assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
+		auth_user_request = r->auth_user_request;
+		assert(auth_user_request->scheme_data != NULL);
+		ntlm_request = auth_user_request->scheme_data;
+		auth_user = auth_user_request->auth_user;
+		ntlm_user = auth_user_request->auth_user->scheme_data;
+		assert(ntlm_user != NULL);
+		result = S_HELPER_RELEASE;
+		/* we only expect OK when finishing the handshake */
+		assert(ntlm_request->auth_state == AUTHENTICATE_STATE_RESPONSE);
+		ntlm_user->username = xstrndup(reply, MAX_LOGIN_SZ);
+		ntlm_request->authhelper = NULL;
+		auth_user->flags.credentials_ok = 1;	/* login ok */
+	    } else if (strncasecmp(reply, "NA ", 3) == 0) {
+		/* TODO: only work with auth_user here if it exists */
+		assert(r->auth_user_request != NULL);
+		assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
+		auth_user_request = r->auth_user_request;
+		auth_user = auth_user_request->auth_user;
+		assert(auth_user != NULL);
+		ntlm_user = auth_user->scheme_data;
+		ntlm_request = auth_user_request->scheme_data;
+		assert((ntlm_user != NULL) && (ntlm_request != NULL));
+		/* todo: action of Negotiate state on error */
+		result = S_HELPER_RELEASE;	/*some error has occured. no more requests */
+		ntlm_request->authhelper = NULL;
+		auth_user->flags.credentials_ok = 2;	/* Login/Usercode failed */
+		debug(29, 4) ("authenticateNTLMHandleReply: Error validating user via NTLM.\n");
+		ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
+		if ((t = strchr(reply, ' ')))	/* strip after a space */
 		    *t = '\0';
-            }
-            else if (strncasecmp(reply, "BH ", 3) == 0) {
-                /* TODO kick off a refresh process. This can occur after a YR or after
-                   a KK. If after a YR release the helper and resubmit the request via 
-                   Authenticate NTLM start. 
-                   If after a KK deny the user's request w/ 407 and mark the helper as 
-                   Needing YR.*/
-                assert(r->auth_user_request != NULL);
-                assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
-                auth_user_request=r->auth_user_request;
-                auth_user        = auth_user_request->auth_user;
-                assert(auth_user != NULL);
-                ntlm_user        = auth_user->scheme_data;
-                ntlm_request     = auth_user_request->scheme_data;
-                assert ((ntlm_user != NULL ) && (ntlm_request != NULL));
-                result=S_HELPER_RELEASE; /*some error has occured. no more requests for 
-                                           this helper */
-                helperstate=helperStatefulServerGetData(ntlm_request->authhelper);
-                ntlm_request->authhelper = NULL;
-                if (ntlm_request->auth_state == AUTHENTICATE_STATE_NEGOTIATE) 
-                {
-                    /* The helper broke on YR. It automatically
-                     * resets */
-                    auth_user->flags.credentials_ok = 3; /* cannot process */
-                    debug(29, 1) ("authenticateNTLMHandleReply: Error obtaining challenge from helper: %d.\n", lastserver);
-                    /* mark it for starving */
-                    helperstate->starve=1;
-                    /* resubmit the request. This helper is currently busy, so we will get
-                     * a different one. */
-                    authenticateNTLMStart(auth_user_request, r->handler, r->data);
-                } else 
-                { 
-                    /* the helper broke on a KK */
-                    /* first the standard KK stuff */
-                    auth_user->flags.credentials_ok = 2; /* Login/Usercode failed */
-                    debug(29, 4) ("authenticateNTLMHandleReply: Error validating user via NTLM.\n");
-                    ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
-                    if ((t = strchr(reply, ' ')))/* strip after a space */
-                        *t = '\0';
-                    /* now we mark the helper for resetting. */
-                    helperstate->starve=1;
-                }
-                ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
-            }
-            else { 
-                /* TODO: only work with auth_user here if it exists */
-                assert(r->auth_user_request != NULL);
-                assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
-                auth_user_request=r->auth_user_request;
-                auth_user        = auth_user_request->auth_user;
-                assert(auth_user != NULL);
-                ntlm_user        = auth_user->scheme_data;
-                ntlm_request     = auth_user_request->scheme_data;
-                assert ((ntlm_user != NULL ) && (ntlm_request != NULL));
-	        debug(29, 1) ("authenticateNTLMHandleReply: Unsupported helper response, '%s'\n", reply);
-                /* restart the authentication process */
-                ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
-                auth_user->flags.credentials_ok = 3; /* cannot process */
-                ntlm_request->authhelper = NULL;
+	    } else if (strncasecmp(reply, "BH ", 3) == 0) {
+		/* TODO kick off a refresh process. This can occur after a YR or after
+		 * a KK. If after a YR release the helper and resubmit the request via 
+		 * Authenticate NTLM start. 
+		 * If after a KK deny the user's request w/ 407 and mark the helper as 
+		 * Needing YR. */
+		assert(r->auth_user_request != NULL);
+		assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
+		auth_user_request = r->auth_user_request;
+		auth_user = auth_user_request->auth_user;
+		assert(auth_user != NULL);
+		ntlm_user = auth_user->scheme_data;
+		ntlm_request = auth_user_request->scheme_data;
+		assert((ntlm_user != NULL) && (ntlm_request != NULL));
+		result = S_HELPER_RELEASE;	/*some error has occured. no more requests for 
+						 * this helper */
+		helperstate = helperStatefulServerGetData(ntlm_request->authhelper);
+		ntlm_request->authhelper = NULL;
+		if (ntlm_request->auth_state == AUTHENTICATE_STATE_NEGOTIATE) {
+		    /* The helper broke on YR. It automatically
+		     * resets */
+		    auth_user->flags.credentials_ok = 3;	/* cannot process */
+		    debug(29, 1) ("authenticateNTLMHandleReply: Error obtaining challenge from helper: %d.\n", lastserver);
+		    /* mark it for starving */
+		    helperstate->starve = 1;
+		    /* resubmit the request. This helper is currently busy, so we will get
+		     * a different one. */
+		    authenticateNTLMStart(auth_user_request, r->handler, r->data);
+		} else {
+		    /* the helper broke on a KK */
+		    /* first the standard KK stuff */
+		    auth_user->flags.credentials_ok = 2;	/* Login/Usercode failed */
+		    debug(29, 4) ("authenticateNTLMHandleReply: Error validating user via NTLM.\n");
+		    ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
+		    if ((t = strchr(reply, ' ')))	/* strip after a space */
+			*t = '\0';
+		    /* now we mark the helper for resetting. */
+		    helperstate->starve = 1;
+		}
+		ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
+	    } else {
+		/* TODO: only work with auth_user here if it exists */
+		assert(r->auth_user_request != NULL);
+		assert(r->auth_user_request->auth_user->auth_type == AUTH_NTLM);
+		auth_user_request = r->auth_user_request;
+		auth_user = auth_user_request->auth_user;
+		assert(auth_user != NULL);
+		ntlm_user = auth_user->scheme_data;
+		ntlm_request = auth_user_request->scheme_data;
+		assert((ntlm_user != NULL) && (ntlm_request != NULL));
+		debug(29, 1) ("authenticateNTLMHandleReply: Unsupported helper response, '%s'\n", reply);
+		/* restart the authentication process */
+		ntlm_request->auth_state = AUTHENTICATE_STATE_NONE;
+		auth_user->flags.credentials_ok = 3;	/* cannot process */
+		ntlm_request->authhelper = NULL;
 	    }
-        } else {
-            fatal("authenticateNTLMHandleReply: called with no result string\n");
-        }
-        r->handler(r->data, NULL);
+	} else {
+	    fatal("authenticateNTLMHandleReply: called with no result string\n");
+	}
+	r->handler(r->data, NULL);
     } else {
-        debug(29,1) ("AuthenticateNTLMHandleReply: invalid callback data. Releasing helper '%d'.\n",lastserver);
-        result=S_HELPER_RELEASE;
+	debug(29, 1) ("AuthenticateNTLMHandleReply: invalid callback data. Releasing helper '%d'.\n", lastserver);
+	result = S_HELPER_RELEASE;
     }
     authenticateStateFree(r);
-    debug(29,9)("NTLM HandleReply, telling stateful helper : %d\n",result);
+    debug(29, 9) ("NTLM HandleReply, telling stateful helper : %d\n", result);
     return result;
 }
 
@@ -553,6 +540,7 @@
 {
     cbdataFree(r);
 }
+
 #endif
 
 static void
@@ -564,21 +552,24 @@
 
 /* is a particular challenge still valid ? */
 int
-authenticateNTLMValidChallenge(ntlm_helper_state_t *helperstate)
+authenticateNTLMValidChallenge(ntlm_helper_state_t * helperstate)
 {
-    if (helperstate->challenge == NULL) return 0;
+    if (helperstate->challenge == NULL)
+	return 0;
     return 1;
 }
 
 /* does our policy call for changing the challenge now? */
 int
-authenticateNTLMChangeChallenge(ntlm_helper_state_t *helperstate)
+authenticateNTLMChangeChallenge(ntlm_helper_state_t * helperstate)
 {
     /* don't check for invalid challenges just for expiry choices */
     /* this is needed because we have to starve the helper until all old
      * requests have been satisfied */
-    if (helperstate->challengeuses>ntlmConfig->challengeuses) return 1;
-    if (helperstate->renewed+ntlmConfig->challengelifetime>=squid_curtime) return 1;
+    if (helperstate->challengeuses > ntlmConfig->challengeuses)
+	return 1;
+    if (helperstate->renewed + ntlmConfig->challengelifetime >= squid_curtime)
+	return 1;
     return 0;
 }
 
@@ -593,46 +584,46 @@
     helper_stateful_server *server;
     ntlm_helper_state_t *helperstate;
     char buf[8192];
-    char *sent_string=NULL;
-    ntlm_user_t * ntlm_user;
-    ntlm_request_t * ntlm_request;
-    auth_user_t * auth_user;
+    char *sent_string = NULL;
+    ntlm_user_t *ntlm_user;
+    ntlm_request_t *ntlm_request;
+    auth_user_t *auth_user;
 
     assert(auth_user_request);
-    auth_user=auth_user_request->auth_user;
-    ntlm_user=auth_user->scheme_data;
-    ntlm_request=auth_user_request->scheme_data;
+    auth_user = auth_user_request->auth_user;
+    ntlm_user = auth_user->scheme_data;
+    ntlm_request = auth_user_request->scheme_data;
     assert(ntlm_user);
     assert(ntlm_request);
     assert(handler);
     assert(data);
-    assert(auth_user->auth_type=AUTH_NTLM);
-    debug(29,9)("authenticateNTLMStart: auth state '%d'\n",ntlm_request->auth_state);
-    switch(ntlm_request->auth_state) {
-        case AUTHENTICATE_STATE_NEGOTIATE:
-            sent_string = xstrdup(ntlm_request->ntlmnegotiate);
-            break;
-        case AUTHENTICATE_STATE_RESPONSE:
-            sent_string = xstrdup(ntlm_request->ntlmauthenticate);
-            assert(ntlm_request->authhelper);
-            debug(29, 9) ("authenticateNTLMStart: Asking NTLMauthenticator '%d'.\n", ntlm_request->authhelper);
-            break;
-        default:
-            fatal("Invalid authenticate state for NTLMStart");
+    assert(auth_user->auth_type = AUTH_NTLM);
+    debug(29, 9) ("authenticateNTLMStart: auth state '%d'\n", ntlm_request->auth_state);
+    switch (ntlm_request->auth_state) {
+    case AUTHENTICATE_STATE_NEGOTIATE:
+	sent_string = xstrdup(ntlm_request->ntlmnegotiate);
+	break;
+    case AUTHENTICATE_STATE_RESPONSE:
+	sent_string = xstrdup(ntlm_request->ntlmauthenticate);
+	assert(ntlm_request->authhelper);
+	debug(29, 9) ("authenticateNTLMStart: Asking NTLMauthenticator '%d'.\n", ntlm_request->authhelper);
+	break;
+    default:
+	fatal("Invalid authenticate state for NTLMStart");
     }
 
-    while (!xisspace(*sent_string))     /*trim NTLM */
-        sent_string++;
+    while (!xisspace(*sent_string))	/*trim NTLM */
+	sent_string++;
 
-    while (xisspace(*sent_string))      /*trim leading spaces */
-        sent_string++;
+    while (xisspace(*sent_string))	/*trim leading spaces */
+	sent_string++;
 
     debug(29, 9) ("authenticateNTLMStart: state '%d'\n", ntlm_request->auth_state);
     debug(29, 9) ("authenticateNTLMStart: '%s'\n", sent_string);
     if (ntlmConfig->authenticate == NULL) {
-        debug(29, 0) ("authenticateNTLMStart: no NTLM program specified:'%s'\n", sent_string);
-//	handler(data,0, NULL);
-            handler(data, NULL);
+	debug(29, 0) ("authenticateNTLMStart: no NTLM program specified:'%s'\n", sent_string);
+//      handler(data,0, NULL);
+	handler(data, NULL);
 	return;
     }
 #ifdef NTLMHELPPROTOCOLV2
@@ -643,76 +634,72 @@
     r->auth_user_request = auth_user_request;
     snprintf(buf, 8192, "%s\n", sent_string);
     helperStatefulSubmit(ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authhelper);
-    debug(29,9)("authenticateNTLMstart: finished\n");
+    debug(29, 9) ("authenticateNTLMstart: finished\n");
 #else
     /* this is ugly TODO: move the challenge generation routines to their own function and
      * tidy the logic up to make use of the efficiency we now have */
-    switch(ntlm_request->auth_state) {
-        case AUTHENTICATE_STATE_NEGOTIATE:
-    /*  
-     * 1: get a helper server
-     * 2: does it have a challenge?
-     * 3: tell it to get a challenge, or give ntlmauthdone the challenge
-     */
-            server=helperStatefulDefer(ntlmauthenticators);
-            helperstate=server ? helperStatefulServerGetData(server): NULL ;
-            while ((server !=NULL) && 
-                 authenticateNTLMChangeChallenge(helperstate)) 
-            {
-                /* flag this helper for challenge changing */
-                helperstate->starve=1;
-                /* and release the deferred request */
-                helperStatefulReleaseServer(server);
-                server=helperStatefulDefer(ntlmauthenticators);
-                if (server != NULL)
-                    helperstate=helperStatefulServerGetData(server);
-            }
-            if (server==NULL) debug(29,9) ("unable to get a deferred ntlm helper... all helpers are refreshing challenges. Queuing as a placeholder request.\n");
-            
-            ntlm_request->authhelper=server;
-            /* tell the log what helper we have been given */
-            debug(29,9)("authenticateNTLMStart: helper '%d' assigned\n",server);
-            /* valid challenge? */
-            if((server == NULL) || !authenticateNTLMValidChallenge(helperstate))
-            {
-                r = CBDATA_ALLOC(authenticateStateData, NULL);
-                r->handler = handler;
-                cbdataLock(data);
-                r->data = data;
-                r->auth_user_request = auth_user_request;
-                if (server == NULL)
-                {
-                    helperStatefulSubmit(ntlmauthenticators, NULL, authenticateNTLMHandleplaceholder, r, ntlm_request->authhelper);
-                }
-                else
-                {
-                    snprintf(buf, 8192, "YR\n");
-                    helperStatefulSubmit(ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authhelper);
-                }
-            } else {
-                /* we have a valid challenge */
-            /* TODO: turn the below into a function and call from here and handlereply */
-            /* increment the challenge uses */
-            helperstate->challengeuses++;
-            /* assign the challenge */
-            ntlm_request->authchallenge =
-                xstrndup(helperstate->challenge, NTLM_CHALLENGE_SZ+5);
-            handler(data, NULL);
-            }
-              
-            break;
-        case AUTHENTICATE_STATE_RESPONSE:
-            r = CBDATA_ALLOC(authenticateStateData, NULL);
-            r->handler = handler;
-            cbdataLock(data);
-            r->data = data;
-            r->auth_user_request = auth_user_request;
-            snprintf(buf, 8192, "KK %s\n", sent_string);
-            helperStatefulSubmit(ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authhelper);
-            debug(29,9)("authenticateNTLMstart: finished\n");
-            break;
-        default:
-            fatal("Invalid authenticate state for NTLMStart");
+    switch (ntlm_request->auth_state) {
+    case AUTHENTICATE_STATE_NEGOTIATE:
+	/*  
+	 * 1: get a helper server
+	 * 2: does it have a challenge?
+	 * 3: tell it to get a challenge, or give ntlmauthdone the challenge
+	 */
+	server = helperStatefulDefer(ntlmauthenticators);
+	helperstate = server ? helperStatefulServerGetData(server) : NULL;
+	while ((server != NULL) &&
+	    authenticateNTLMChangeChallenge(helperstate)) {
+	    /* flag this helper for challenge changing */
+	    helperstate->starve = 1;
+	    /* and release the deferred request */
+	    helperStatefulReleaseServer(server);
+	    server = helperStatefulDefer(ntlmauthenticators);
+	    if (server != NULL)
+		helperstate = helperStatefulServerGetData(server);
+	}
+	if (server == NULL)
+	    debug(29, 9) ("unable to get a deferred ntlm helper... all helpers are refreshing challenges. Queuing as a placeholder request.\n");
+
+	ntlm_request->authhelper = server;
+	/* tell the log what helper we have been given */
+	debug(29, 9) ("authenticateNTLMStart: helper '%d' assigned\n", server);
+	/* valid challenge? */
+	if ((server == NULL) || !authenticateNTLMValidChallenge(helperstate)) {
+	    r = CBDATA_ALLOC(authenticateStateData, NULL);
+	    r->handler = handler;
+	    cbdataLock(data);
+	    r->data = data;
+	    r->auth_user_request = auth_user_request;
+	    if (server == NULL) {
+		helperStatefulSubmit(ntlmauthenticators, NULL, authenticateNTLMHandleplaceholder, r, ntlm_request->authhelper);
+	    } else {
+		snprintf(buf, 8192, "YR\n");
+		helperStatefulSubmit(ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authhelper);
+	    }
+	} else {
+	    /* we have a valid challenge */
+	    /* TODO: turn the below into a function and call from here and handlereply */
+	    /* increment the challenge uses */
+	    helperstate->challengeuses++;
+	    /* assign the challenge */
+	    ntlm_request->authchallenge =
+		xstrndup(helperstate->challenge, NTLM_CHALLENGE_SZ + 5);
+	    handler(data, NULL);
+	}
+
+	break;
+    case AUTHENTICATE_STATE_RESPONSE:
+	r = CBDATA_ALLOC(authenticateStateData, NULL);
+	r->handler = handler;
+	cbdataLock(data);
+	r->data = data;
+	r->auth_user_request = auth_user_request;
+	snprintf(buf, 8192, "KK %s\n", sent_string);
+	helperStatefulSubmit(ntlmauthenticators, buf, authenticateNTLMHandleReply, r, ntlm_request->authhelper);
+	debug(29, 9) ("authenticateNTLMstart: finished\n");
+	break;
+    default:
+	fatal("Invalid authenticate state for NTLMStart");
     }
 #endif
 }
@@ -721,77 +708,76 @@
 int
 authenticateNTLMHelperServerAvailable(void *data)
 {
-    ntlm_helper_state_t *statedata=data;
-    if (statedata != NULL)
-    {
-        if (statedata->starve)
-        {
-            debug(29,4)("authenticateNTLMHelperServerAvailable: starving - returning 0\n");
-            return 0;
-        }
-        else 
-        {
-            debug(29,4)("authenticateNTLMHelperServerAvailable: not startving - returning 1\n");
-            return 1;
-        }
+    ntlm_helper_state_t *statedata = data;
+    if (statedata != NULL) {
+	if (statedata->starve) {
+	    debug(29, 4) ("authenticateNTLMHelperServerAvailable: starving - returning 0\n");
+	    return 0;
+	} else {
+	    debug(29, 4) ("authenticateNTLMHelperServerAvailable: not startving - returning 1\n");
+	    return 1;
+	}
     }
-    debug(29,4)("authenticateNTLMHelperServerAvailable: no state data - returning 0\n");
+    debug(29, 4) ("authenticateNTLMHelperServerAvailable: no state data - returning 0\n");
     return 0;
 }
 
 void
 authenticateNTLMHelperServerOnEmpty(void *data)
 {
-    ntlm_helper_state_t *statedata=data;
-    if (statedata == NULL) return;
-    if (statedata->starve)
-    {
-        /* we have been starving the helper */
-        debug(29,9)("authenticateNTLMHelperServerOnEmpty: resetting challenge details\n");
-        statedata->starve=0;
-        statedata->challengeuses=0;
-        statedata->renewed=0;
-        xfree(statedata->challenge);
-        statedata->challenge=NULL;
+    ntlm_helper_state_t *statedata = data;
+    if (statedata == NULL)
+	return;
+    if (statedata->starve) {
+	/* we have been starving the helper */
+	debug(29, 9) ("authenticateNTLMHelperServerOnEmpty: resetting challenge details\n");
+	statedata->starve = 0;
+	statedata->challengeuses = 0;
+	statedata->renewed = 0;
+	xfree(statedata->challenge);
+	statedata->challenge = NULL;
     }
 }
 
 
 /* clear the NTLM helper of being reserved for future requests */
 void
-authenticateNTLMReleasehelper(auth_user_request_t *auth_user_request){
-    ntlm_request_t * ntlm_request;
-    assert(auth_user_request->auth_user->auth_type==AUTH_NTLM);
+authenticateNTLMReleasehelper(auth_user_request_t * auth_user_request)
+{
+    ntlm_request_t *ntlm_request;
+    assert(auth_user_request->auth_user->auth_type == AUTH_NTLM);
     assert(auth_user_request->scheme_data != NULL);
     ntlm_request = auth_user_request->scheme_data;
-    debug(29,9) ("authenticateNTLMReleasehelper: releasing helper '%d'\n",ntlm_request->authhelper);
+    debug(29, 9) ("authenticateNTLMReleasehelper: releasing helper '%d'\n", ntlm_request->authhelper);
     helperStatefulReleaseServer(ntlm_request->authhelper);
-    ntlm_request->authhelper=NULL;
+    ntlm_request->authhelper = NULL;
 }
 
 /* clear any connection related authentication details */
 void
-authenticateNTLMOnCloseConnection(ConnStateData *conn) {
-    ntlm_request_t * ntlm_request;
-    assert(conn !=NULL);
+authenticateNTLMOnCloseConnection(ConnStateData * conn)
+{
+    ntlm_request_t *ntlm_request;
+    assert(conn != NULL);
     if (conn->auth_user_request != NULL) {
-        assert(conn->auth_user_request->scheme_data != NULL);
-        ntlm_request = conn->auth_user_request->scheme_data;
-        if (ntlm_request->authhelper != NULL)
-            authenticateNTLMReleasehelper(conn->auth_user_request);
-        /* unlock the connection based lock */
-        debug (29,9)("authenticateNTLMOnCloseConnection: Unlocking auth_user from the connection.\n");
-        authenticateAuthUserRequestUnlock(conn->auth_user_request);
-        conn->auth_user_request = NULL;
+	assert(conn->auth_user_request->scheme_data != NULL);
+	ntlm_request = conn->auth_user_request->scheme_data;
+	if (ntlm_request->authhelper != NULL)
+	    authenticateNTLMReleasehelper(conn->auth_user_request);
+	/* unlock the connection based lock */
+	debug(29, 9) ("authenticateNTLMOnCloseConnection: Unlocking auth_user from the connection.\n");
+	authenticateAuthUserRequestUnlock(conn->auth_user_request);
+	conn->auth_user_request = NULL;
     }
 }
 
 /* authenticateUserUsername: return a pointer to the username in the */
 char *
-authenticateNTLMUsername(auth_user_t *auth_user) {
-    ntlm_user_t * ntlm_user=auth_user->scheme_data;
-    if(ntlm_user)
-        return ntlm_user->username;
+authenticateNTLMUsername(auth_user_t * auth_user)
+{
+    ntlm_user_t *ntlm_user = auth_user->scheme_data;
+    if (ntlm_user)
+	return ntlm_user->username;
     return NULL;
 }
 
@@ -802,41 +788,42 @@
  */
 
 void
-authenticateDecodeNTLMAuth(auth_user_request_t *auth_user_request, const char * proxy_auth) 
+authenticateDecodeNTLMAuth(auth_user_request_t * auth_user_request, const char *proxy_auth)
 {
-    dlink_node * node;
+    dlink_node *node;
     assert(auth_user_request->auth_user == NULL);
-    auth_user_request->auth_user=authenticateAuthUserNew("ntlm");
+    auth_user_request->auth_user = authenticateAuthUserNew("ntlm");
     auth_user_request->auth_user->auth_type = AUTH_NTLM;
     auth_user_request->auth_user->scheme_data = memPoolAlloc(ntlm_user_pool);
     auth_user_request->scheme_data = memPoolAlloc(ntlm_request_pool);
     /* lock for the auth_user_request link */
     authenticateAuthUserLock(auth_user_request->auth_user);
-    node=dlinkNodeNew();
+    node = dlinkNodeNew();
     dlinkAdd(auth_user_request, node, &auth_user_request->auth_user->requests);
-    
+
     /* all we have to do is identify that it's NTLM - the helper does the rest */
     debug(29, 9) ("authenticateDecodeNTLMAuth: NTLM authentication\n");
     return;
 }
 
-int authenticateNTLMcmpUsername(ntlm_user_t *u1, ntlm_user_t *u2) 
+int
+authenticateNTLMcmpUsername(ntlm_user_t * u1, ntlm_user_t * u2)
 {
     return strcmp(u1->username, u2->username);
 }
 
 void
-authenticateProxyAuthCacheAddLink(const char *key, auth_user_t *auth_user)
+authenticateProxyAuthCacheAddLink(const char *key, auth_user_t * auth_user)
 {
     auth_user_hash_pointer *proxy_auth_hash;
-    ntlm_user_t * ntlm_user;
+    ntlm_user_t *ntlm_user;
     proxy_auth_hash =
-        memAllocate(MEM_AUTH_USER_HASH);
+	memAllocate(MEM_AUTH_USER_HASH);
     proxy_auth_hash->key = xstrdup(key);
     proxy_auth_hash->auth_user = auth_user;
-    ntlm_user=auth_user->scheme_data;
+    ntlm_user = auth_user->scheme_data;
     dlinkAddTail(proxy_auth_hash, &proxy_auth_hash->link,
-        &ntlm_user->proxy_auth_list);
+	&ntlm_user->proxy_auth_list);
     hash_join(proxy_auth_cache, (hash_link *) proxy_auth_hash);
 }
 
